-------------------------------------------------------------------

Changes in stable release 2.4.20 (6-Dec-2006)

* The configure script now correctly appends executable file
  extensions to conditionally built binaries. Fixes building on
  Cygwin.

* FvwmConsole no longer conflicts with getline of Cygwin's stdio.

* Fixed parsing of For loops in FvwmScript.

* Fixed a possible endless loop when de-iconifying a transient
  window.

* Reject some invalid GNOME hints.

* Fixed a loop when xterm changes its "active icon" size.

* The configure script can now cope with four-part version numbers
  when detecting some libraries.

* Security fixes in

     fvwm-menu-directory. (CVE-2006-5969)
     FvwmCommand

-------------------------------------------------------------------

Changes in stable release 2.4.19 (30-Sep-2004)

* Fixed BackingStore style option.

* Fixed MoveToDesk commend with a single argument.

* Allow whitespace in menu names.

* Fixed a hang when restarting FvwmCommand or FvwmConsole.

* A double click no longer occurs when two different mouse
  buttons are pressed.

* Fixed a relief drawing problem in FvwmWinList.

* Fixed traveling windows on restart if a window used non NorthWest
  gravity and changed that before the restart.

* Fixed installation of FvwmGtk.1 for debian (with DESTDIR set).

* The clock in FvwmTaskBar is redrawn immediately when its colour
  changes.

* The option CurrentGlobalPageAnyDesk was accidentally named
  CurrentGlobbalPageAnyDesk before.

* Fixed a problem with fvwm startup and shutdown when the pointer
  was grabbed by another application.

* Fixed parsing of the Pointer option to the Move command.

* Fixed handling of MWM hints on 64 bit machines.

-------------------------------------------------------------------

Changes in stable release 2.4.18 (19-Mar-2004)

* Corrected rebooting the machine in FvwmScript-Quit.

* Fixed the FlickeringMoveWorkaround option to the BugOpts command.

* Security patch in fvwmbug.sh.
  See http://securitytracker.com/alerts/2004/Jan/1008781.html

* Security fixes in
    fvwm-menu-directory (BugTraq id 9161)
    fvwm_make_directory_menu.sh
    fvwm_make_browse_menu.sh

* Fixed installation of FvwmGtk.1.

-------------------------------------------------------------------

Changes in stable release 2.4.17 (10-Oct-2003)

* Fixed error message for incorrect --with-SOME-library argument.

* It is now possible to suppress title action or title completely
  in menus created by fvwm-menu-directory.

* Fixed a compile problem on QNX 4.25.

* New configure switch --disable-gtk.

* FvwmGtk.1 is not installed if FvwmGtk is not built.

* The "Visible" condition does no longer select windows on
  different desks.

* With the styles StartsOnPage, SkipMapping and UsePPosition,
  windows that request a specific position are still placed on the
  given page.

* Fixed sending M_NEW_PAGE packets to the modules if the page did
  not change.

* Added support for new BBC headlines in fvwm-menu-headlines, this
  replaces the old BBC-Worlds and BBC-SciTech headlines.

-------------------------------------------------------------------

Changes in stable release 2.4.16 (30-May-2003)

* Fixed a transparency problem in FvwmButtons.

* The PageOnly option in FvwmTaskBar now works after a desk change
  too.

* Fixed a possible core dump when more than 256 windows are on
  the desktop.

* Initial drawing and final undrawing of wire frame no longer
  toggles the pixel in the top left corner of the screen.

* Fixed parsing of button geometries in FvwmButtons when the
  geometry specificaiton appeared after another option with a comma
  at the end.

* FvwmCommand works too when invoked without the DISPLAY variable
  set.

* Fixed displaying iconified windows without an icon in
  FvwmIconMan.

* All single letter variables are deprecated now; new variables:

    $[w.id], $[w.name], $[w.iconname], $[w.class], $[w.resource],
    $[desk.n], $[version.num], $[version.info], $[version.line],
    $[desk.pagesx], $[desk.pagesy]

* Fixed a bug with aspect pixmaps in colorsets.

* Iconified windows without an icon do not receive focus.

* Fixed a bug in FvwmPager that displayed iconified windows without
  icon title or picture as not iconified.

* Fixed parsing of '@<screen>' Xinerama specification in the
  ButtonGeometry option of FvwmButtons.

* The NoWarp menu position hint option works with root menus too.

* Fixed a problem with styles not being properly applied after a
  DestroyStyle command.

* Fixed a bug introduced in 2.4.14.  The pointer was sometimes
  warped to another screen during a restart and command execution.

* Fixed a crash when a window was destroyed twice in a complex
  function.

* Fixed corruption of the window list when windows died at the
  wrong time.

* Fixed problem with empty frame windows if X recycled the window
  id of a window that died recently.

* Fixed loading of application supplied pixmap on 8/24 depth screen.

* WindowListFunc is executed now within a window context, so
  a prefix "WindowId $0" is not needed in its definition anymore
  and it is advised to remove it in user configs.

* FvwmEvent now executes all window related events within a window
  context, so PassId is not needed anymore, and all prefixes
  "WindowId $0" may be removed in user event handlers.

* Fixed "GotoDeskAndPage prev" on desks larger than 2x2.

* Expansion of variables like $[w.name] or $[EMPTY_STRING] that are
  empty works.

-------------------------------------------------------------------

Changes in stable release 2.4.15 (24-Jan-2003)

* Fix for gmplayer launched by fvwm.  Close stdin on Exec so the
  exec'd process knows its not running interactively.

* Windows using the WindowListSkip style do not appear in the
  FvwmTaskBar at random.

* Fixed a memory leak in ChangeIcon, ChangeForeColor and
  ChangeBackColor FvwmScript Instruction.

* Fixed a core dump in the parsing of FvwmAuto arguments.

* Fixed screwed calculation of icon picture size when application
  specifies it explicitly.

* The option ShowOnlyIcons now works as described in the
  FvwmIconMan man page.  It was accidentally named ShowOnlyIconic
  before.

-------------------------------------------------------------------

Changes in stable release 2.4.14 (29-Nov-2002)

* Modules do not crash anymore when more than 126 windows are on
  the desktop.

* FvwmIconMan displays windows correctly that were iconified and
  then moved to another page.

* Application provided icon windows no longer appear at 0 0 when
  restarting.

* The built-in session management can handle window names, classes
  etc. beginning with whitespace (textedit).

* Removed the flawed "A"ny context key binding patch from 2.4.13.

* The default EdgeScroll (if not specified) was incorrectly
  assumed to be 100 pixels instead of 100 percents.

* Icons no longer appear on top of all other windows after a
  restart.

-------------------------------------------------------------------

Changes in stable release 2.4.13 (1-Nov-2002)

* Icon titles for windows with an icon position hint no longer
  appear at random places.

* Fvwm no longer displays two icon pictures when switching from
  NoIconOverride to IconOverride with windows that provide their
  own icon window.

* The Current, All, Pick, ThisWindow and PointerWindow commands
  work on shaded windows too.

* Fixed a problem stacking iconified transients.

* No more flickering when raising transients.

* Fixed a number of problems with window stacking, some new in
  2.4.10 or later, some older problems that have been around for a
  long time.

* Windows starting lowered or on any layer other than the default
  layer are displayed at the right place in FvwmPager.

* Bindings with the "A"ny context can not be overridden by Gnome
  panel or OpenOffice.

-------------------------------------------------------------------

Changes in stable release 2.4.12 (10-Oct-2002)

* Fixed drawing problems with TiledPixmap and Solid MenuFaces which
  appeared in 2.4.10, replacing the same problem with ?Gradient
  MenuFaces in 2.4.9.

* Fixed accidental menu animation with certain menu position hints.

* Increased maximum allowed key symbol name length to 200
  characters.

* Allow quotes in conditional command conditions.

* Fixed starting Move at random position when pointer is on a
  different screen.

* Transient windows do not appear in FvwmWinList after they have
  been moved on the desktop.

-------------------------------------------------------------------

Changes in stable release 2.4.11 (20-Sep-2002)

* Allow the use of mouse buttons other than the first in
  FvwmWinList when invoked transient.

* Fixed a crash with ssh-askpass introduced in 2.4.10.

-------------------------------------------------------------------

Changes in stable release 2.4.10 (15-Sep-2002)

* The commands Maximize, Resize and ResizeMove can be used on icons
  as it was in 2.2.x.

* Fixed hilighting of menu items with HGradient and VGradient
  MenuFace.  Reduced flickering with these options.

* Fixed a minor problem with entering submenus via keyboard.

* Fixed race conditions in FvwmTaskBar with AutoStick that caused
  it to hang.

* Fixed drawing of pager balloons with BalloonBack option.

* Fixed drawing of SidePic menu background with B/D gradients.

* Fixed drawing of menu item reliefs with gradient menu faces.

* Fixed key bindings on window corners.

* Fixed FvwmTaskBar i18n font loading

* Fixed StackTransientParent style without RaiseTransient or
  LowerTransient on the parent window.

* StackTransientParent works only on parent window if it is on the
  same layer.

* Fixed handling of window group hint with the (De)Iconify
  command.

* No more flickering when a transient overlapping its parent window
  is lowered.

* Fixed hilighting of unfocused windows.

-------------------------------------------------------------------

Changes in stable release 2.4.9 (11-Aug-2002)

* Fixed interaction bug between CascadePlacement and StartsOnPage -
  if the target page was at a negative x or y page displacement
  from the current viewport, the window would be placed on the
  wrong page.

* Fixed a problem with colormap transition when a transient window
  died.

* Fixed a FvwmScript crash with Swallow widget and very long window
  names.

* Restored old way of handling clicks in windows with ClickToFocus
  and ClickToFocusPassesClickOff.  This fixes a problem with
  click+drag in an unfocused rxvt or aterm window.

* Fixed problems with $fg and $bg variables in FvwmButtons when the
  UseOld option was used.

* Fixed wrong warp coordinates when WarpToWindow was used with two
  arguments on an unmanaged window.

* Added a workaround for popup menus in TK applications that appear
  on some random position.

* Fixed problems with wish scripts creating windows that start
  iconic.

* Fixed the NoClose option with unmapped panels in FvwmButtons.

* A number of drawing fixes in FvwmPager.

* fixed a slight bug when waiting until all buttons are released,
  for example after executing a complex function.

* Fixed potentially harmful change in module interface.

* Fixed displaying menu items with icons when using the MenuStyle
  SubmmenusLeft.

* Fixed problems with the pointer moving off screen in a multi
  head setup.

* Fixed a potential crash with windows being destroyed during a
  recapture operation.

* Fixed a memory leak in some modules when not using glibc.

* Applications using Mwm hints can now enforce that a window can
  not be moved.

* Fixed negative arguments of WarpToWindow when used on an
  unmanaged window.

* DESTDIR may be fully used again (only useful for distributors).

* Fixed a key binding problem with key symbols that are generated
  by several keys.

* Fixed a possible crash when a window was recaptured and the
  focus could not be transfered to another window.

* Fixed a minor problem with clicks on focused windows being
  ignored.

* fvwm-menu-headlines: added support for CNN and BBC headlines.

* Fixed a performance problem with large numbers of mouse binding
  commands.

-------------------------------------------------------------------

Changes in stable release 2.4.8 (11-Jun-2002)

* A fix for switching between czech and us keyboard layout.

* Remember the icon position when an icon is moved
  non-interactively.

* Setup "fvwm" and "fvwm-root" name symlinks for the executable and
  the man page when installing, see INSTALL.fvwm.

* Fixed another problem with the DeskOnly option and sticky icons
  in FvwmTaskBar.

* New FvwmIconMan configuration syntax now conforms to the syntax of
  other modules, see the man page.

* New WindowList option CurrentAtEnd.

* Fixed maximal length of a named module packet

* Fixed a crash on a config with a new 2.5.x Colorset command.

* Always display the current desk number in the FvwmPager window
  title.

* Allow to bind a function to the focus click and pass it to the
  application at the same time.

* Fixed a problem with fvwm not accepting keyboard input when the
  application with the focus vanished at the start of a session.

* A small security patch regarding TMPDIR.

* Fixed a problem with colormap transition when a transient window
  died.

* Fixed calculation of average bg colour in colour sets with large
  pictures.

* Fixed some minor problems regarding the multibyte patch.

* Fixed selection in FvwmScript List widget.

* fvwm-menu-headlines: updated the site data, added a configurable
  timeout on socket reading (20 sec) to avoid fvwm hanging, new
  --icon-error option.

* Fixed a problem with ClickToFocus + ClickToFocusRaisesOff and
  windows that are below others.

* Fixed the ClickToFocusPassesClick style.

* Fixed CascadePlacement for huge windows, so that the top-left
  corner is always visible.

* Fixed parsing of SendToModule with the first parameter quoted.

* Fonts in double quotes now should work in module configurations.

* Fixed copying PopupOffset values in CopyMenuStyle.

-------------------------------------------------------------------

Changes in stable release 2.4.7 (11-Apr-2002)

* Fixed parsing of WindowList with conditions and a position at
  the same time that was broken in 2.4.6.

* Fixed some problems with the DeskOnly option of FvwmTaskBar
  (windows were duplicated when moving to a different Desk; the
  StickyIcon style was ignored).

* Fixed config.h warnings with some compilers introduced in 2.4.6.

* Fixed icon titles being raised when they should not be.

* Fixed initial drawing of the internals of the FvwmPager window.

* Fixed the FvwmAudio compatible mode in FvwmEvent when external
  audio player is used.

* Fixed execution on QNX.

Changes in stable release 2.4.6 (10-Mar-2002)

* Better support of non ISO-8859-1 window and icon titles. See the
  --disable-compound-text option in INSTALL.fvwm for more details.

* Improved speed of opaque window movement/resizing.

* Fixed a bug that caused windows not being raised and lowered
  properly.

* Suppress error message when using XBM icons.

* Fixed a read descriptor problem in FvwmTaskBar

* Fixed a minor colour update bug in the pager.

* Fixed an fvwm crash when a module died at the wrong moment;
  specifically a transient FvwmPager of FvwmIconMan.

* Fixed placement of WindowList on wrong Xinerama screen when
  called without any options on a screen other than the primary
  screen.

* Fixed a problem with root bindings and xfishtank.

* Fixed moving windows with the keyboard over the edge of the
  screen when the pointer remained of the previous page.

* Do not hilight windows after ResizeMove.

* New conditional command ThisWindow.

* Some fixes in the configure script that caused some rare
  problems detecting gnome and ncurses.

* Fixed a memory leak in the Pick command.

* Allow to choose windows with CirculateSkip with the Pick
  command.

* Fixed an FvwmScript compile problem on dec-osf5.

* The window handles are now resizes as they should when the
  HandleWidth style changes.

* The Current command does not select a random window when no
  window has the focus.

* Fixed a rare menu placement problem with Xinerama.

Changes in stable release 2.4.5 (27-Jan-2002)

* Fixed minor problems in popping sub menus up and down.

* Fixed moving windows between pages with the keyboard.

* Fixed the size of the geometry window that was broken sometimes.

* Fixed problem with pointer warping to another screen on a dual
  head setup.

* Fixed a problem with the focus in internal Ddd and Netscape
  windows.

* Reduced the time in which fvwm attempts to grab the pointer.

* Fixed unmanaged window when window was mapped/unmapped/mapped
  too fast.

* Fixed MiniScroll's auto repeating in FvwmScript.

* Fixed a crash with the UseStyle style in combination with
  HilightBack.

* Fixed excessive redraws of the windows under a window being
  shaded.

* Fixed a minor memory leak in the Style command.

* Fixed pixmap background of FvwmButtons behind buttons with only
  text.

* Fixed a crash in FvwmIconBox when the application provided an
  illegal icon.

* Fixed a configure problem with libstroke-0.5.1.

* New style BackingStoreWindowDefault which is the default
  now. Fvwm no longer disables backing store on windows by
  default.

* Fixed bug that sometimes caused unnecessary redraws when a style
  was changed.

* Fixed crash when something like "$[$v]" appeared in a command.

* Fixed parsing of conditions with more than one comma.

Changes in stable release 2.4.4 (16-Dec-2001)

* Minor title drawing fixes.

* Fixed manual placement with Xinerama.

* Minor button 3 handling fix in FvwmPager.

* Fixed *FvwmIconMan*shaped option with empty managers.

* Fixed ClickToFocusClickRaises style.

* FvwmForm: Customize pointers, support ISO_Tab key, buttons can
  activate on press or release, special pointer during grab, arrow
  keys useful in form with one input field.

* New OpaqueMoveSize argument "unlimited".

* Fixed binding keys with and without "Shift" modifier under some
  circumstances.

* Fixed binding actions to the client window with ClickToFocus.

* Mouse bindings are activated without a recapture.

* FvwmScript: new keyboard bindings. New flags NoFocus and Left,
  Center, and Right for text position. Amelioration of the Menu
  and PopupMenu Widgets. New functions GetPid, Parse,
  SendMsgAndGet and LastString.  New instruction Key for key
  bindings. New command SendToModule ScriptName SendString.

* Command "Silent" when precedes "Key", "Mouse" and "PointerKey"
  disables warning messages.

* Restored the default Alt-Tab behaviour from 2.4.0.

Changes in stable release 2.4.3 (08-Oct-2001)

* Fixed activation of shape extension.

* Fixed problems with overriding key bindings.

* Single letter key names are allowed in upper and lower case in
  key bindings as before 2.4.0.

* Fixed WindowList placement with Xinerama.

* Fixed flickering icon titles.

* New X resource fvwmscreen to select the Xinerama screen on which
  to place new windows.

* Coordinates of a window during motion are show relative to the
  Xinerama screen.

* Some icon placement improvements with Xinerama.

Changes in stable release 2.4.2 (16-Sep-2001)

* Desk and page can be given as X resources in .Xdefaults, for
  example:
    xterm.desk: 1
    xterm.page: 1 2 3

* Several Shape compilation problems fixed.

Changes in stable release 2.4.1 (15-Sep-2001)

* Added Xinerama and SingleLogicalScreen support.

* New commands Xinerama, XineramaPrimaryScreen, XineramaSls,
  XineramaSlsSize and MoveToScreen.

* New context rectangle option XineramaRoot for the menu commands.

* New conditions CurrentGlobalPage, CurrentGlobalPageAnyDesk and
  AcceptsFocus for conditional commands.

* The DestroyStyle command takes effect immediately.

* New style option StartsOnScreen.

* New style options NoUSPosition, UseUSPosition,
  NoTransientPPosition, UseTransientPPosition,
  NoTransientUSPosition, and UseTransientUSPosition.  These work
  similar to the old styles NoPPosition and UsePPosition.

* New option "screen" for Maximize command.

* New option ReverseOrder for WindowList command.

* The default Alt-Tab binding works more intuitive.

* New condition "PlacedByFvwm"

* New Geometry option for FvwmForm.

* New Screen resolution and ShowOnlyIcons options for FvwmIconMan.

* FvwmIconMan can be closed with Delete or Close too.

* New options PageOnly and ScreenOnly for FvwmTaskBar.

* FvwmIconBox, FvwmTaskBar and FvwmWinList support aliases.

* Enhancements in fvwm-menu-headlines and support for 10 more
  sites.

* Color enhancements in button vectors: @2 is bg color, @3 is fg
  color.

* Improved detection of the Shape library.

* Fixed FvwmButtons button titles not being erased for swallowed
  windows that showed up on certain setups.

* Fixed bug that caused transient windows to be buried below their
  parents with the "BugOpts RaiseOverUnmanaged on".  This occured
  with the system.fvwm2rc-sample-95 configuration.

* The modules FvwmPager, FvwmIconMan, FvwmWinList and FvwmButtos
  set the transient_for hint when started with the "transient"
  option.

* Fixed FvwmIconMan with the transient option when mapped off
  screen.

* Fixed ClickToFocus focus policy when iconifying the focused
  window.

* Fixed some focus problems in conjunction with unclutter vs
  xv/xmms and Open Look applications.

* Fixed a problem that could cause windows to be lost off screen
  with interactive window motion.

* Fixed some FvwmTaskBar autohide problem.

* Fixed a display string problem in FvwmForm.

* Fixed a problem with FvwmTheme shadow colours.

* Fixed the CirculateSkipIcon and CirculateSkipShaded options in
  conditional commands.

* Fixed a formatting problem of the man page on AIX, Solaris, and
  some other UNIX variants.

* Fixed a problems with FvwmIconBox exiting on 64 bit platforms.

* Fixed FvwmIconBox crashes with MaxIconSize dimensions 0.

* Fixed parameters of fvwm24_convert.

* Fixed a number of building problems related to old vendor
  unices, libstroke-0.5, autoconf-2.50, bogus gnome-config and
  imlib-config.

* Fixed drawing of title bar buttons with MWMDecorStick.

* Fixed missing button or key events over the pan frames.

* Fixed placement of the FvwmDragWell, FvwmButtons and FvwmForm
  modules.

* Fixed parsing double quotes in FvwmPager's Font and SmallFont
  options.  Fixed FvwmPager crash with certain font strings.

* Fixed drawing of the grid lines in an iconified FvwmPager
  window.

* Fixed button grabbing problem for buttons > 3 in FvwmTaskBar.

* Fixed some exotic problems with window gravity and resizing
  windows.

* Fixed a problem with maximizing windows with the vieport not
  starting on a page boundary.

* Fixed handling of parentheses in FvwmButtons button actions.

* Work around a key binding problem with keys that generate the
  same symbol with more than one key code (e.g. Shift-F1 = F11).

* The Desk option of FvwmBacker is compatible to earlier version.
  Desk or Page coordinates can be omitted to indicate that desk or
  page changes trigger no action at all.

* Fixed double updating of background with FvwmBacker sometimes
  leading to the wrong background.

* Fixed several escaping errors in fvwm-menu-directory, so files
  and directories containing special chars and spaces should work.

* Fixed PlacedByButton3 condition.

* Fixed vanishing windows when mapping/unmapping too fast.

* Fixed prev option of the GotoDeskAndPage command.

* Fixed calculations of X_RESOLUTION and Y_RESOLUTION for screen
  dimmensions larger than 2147.

* Fixed compatibility of the FvwmM4 modules on platforms that have
  a System V implementation of m4 (Solaris 2.6).

* The SetEnv command without a value for a variable is the same as
  UnsetEnv.

* Fixed shading/unshading shaped windows and windows without title
  and border.

Changes in stable release 2.4.0 (03-Jul-2001)

* Finally released. :)

Changes in beta release 2.3.33 (22-Jun-2001)

* Module configuration commands are now partially expanded similar
  to any other commands, except that single alphabetic-letter
  parameters are not expanded for backward compatibility.

Changes in beta release 2.3.32 (4-May-2001)

* Fixed several focus problems and several core dumps.

* Again allow full words "Click", "Hold" as function specifiers
  for backward compatibility.  Please don't use them.

* New configure --enable-command-log option.

* Fixed gdk-imlib configure detection for FvwmGtk.

Changes in beta release 2.3.31 (7-Apr-2001)

* New option "recreate" to DestroyDecor command.

Changes in beta release 2.3.30 (29-Mar-2001)

* The configure option --disable-modality was removed.

* New FvwmCommand -c option to read multiple commands from
  standard input.

Changes in beta release 2.3.29 (2-Mar-2001)

* New temporary option -debug_stack_ring.

* New styles IconifyWindowGroupsTogether and
  IconifyWindowGroupsOff.

* New styles KeepWindowGroupsOnDesk and ScatterWindowGroups to
  cope with applications using the window group hint incorrectly
  (mozilla).

* New BugOpts option FlickeringQtDialogsWorkaround.

* New configure option --disable-package-subdirs, see INSTALL.fvwm
  for info.

* New option "None" to the IconBox style.

Changes in beta release 2.3.28 (25-Jan-2001)

* Renamed configure option --enable-kanji to --enable-multibyte.

* Security fix related to .fvwm2rc being searched in the current
  directory when $HOME is not set.

* New menu styles PopdownImmediately, PopdownDelayed and PopdownDelay.

* New command CopyMenuStyle.

* Replaced Dumb/SmartPlacement, Active/RandomPlacement, SmartPlacement/Off
  style by ManualPlacement / CascadePlacement / MinOverlapPlacement /
  MinOverlapPercentPlacement / TileManualPlacement /TileCascadePlacement
  (old style still supported).

* Replaced ActivePlacementHonorsStartsOnPage with
  ManualPlacementHonorsStartsOnPage and
  ActivePlacementHonorsStartsOnPageOff with
  ManualPlacementHonorsStartsOnPageOff.

* We have two "clever" placement algorithms: MinOverlapPlacement (the old one)
  and MinOverlapPercentPlacement.

Changes in beta release 2.3.27 (3-Jan-2001)

Changes in beta release 2.3.26 (26-Dec-2000)

Changes in beta release 2.3.25 (5-Dec-2000)

* Removed the now obsolete 'Recapture' option of the BusyCursor command.

Changes in beta release 2.3.24 (28-Nov-2000)

* WindowId and WarpToFunction have been enhanced to handle windows on
  different screens and unmanaged windows.

* New command FakeClick.

Changes in beta release 2.3.23 (25-Nov-2000)

* New styles UseIconPosition (default) and NoIconPosition.

* Better focus handling on multi head displays.

Changes in beta release 2.3.22 (10-Nov-2000)

* Configuration samples of FvwmForm and FvwmScript installed with fvwm are
  converted to the scheme: "FvwmForm-RootCursor", "FvwmScript-FileBrowser".

* New expanding variables: $., $[page.nx], $[page.ny].

* New command UnsetEnv unsets environment variables, compliments SetEnv.

* Pressing mouse button 2 in an FvwmIdent window restarts FvwmIdent
  and asks for a new window.

* New window styles GNOMEIgnoreHints and GNOMEUseHints to disable
  GNOME hints for specific windows even if GNOME compliance is
  compiled in.

* DestroyModuleConfig supports a non-conflicting syntax.

* Speed up command execution and startup.

* Improved handling of windows that set the "input focus" hint to "false".

Changes in beta release 2.3.21 (September 2000)

* Module configuration syntax now accepts a delimiter - colon and optional
  spaces; the old syntax is supported as usual (but it allows conflicts):
    *FvwmIconBoxMaxIconSize 48x48
    *FvwmIconBox: MaxIconSize 48x48

* SendToModule can accept aliases too.

* New option StrokeWidth for StrokeFunc.

* GNOME support is now "on" by default.

Changes in beta release 2.3.20 (July 2000)

* KillModule supports an optional alias parameter as given in Module.
    Module FvwmModule Alias
    KillModule FvwmModule Alias

Changes in beta release 2.3.19 (June 2000)

* New command UpdateStyles forces an immediate style update, even
  within a complex function.

* Implemented '$*' in complex functions.  This works like in a
  shell and is replaced by all arguments of a function.

* Implemented several new parameters:
    $[desk.width], $[desk.height], $[vp.x], $[vp.y], $[vp.width], $[vp.height],
    $[w.x], $[w.y], $[w.width], $[w.height], $[screen], $[<env-var>]

Changes in beta release 2.3.18 (May 2000)

* Renamed the MovedButton3 contition to PlacedByButton3.

* Removed FlipTransient and DontFlipTransient styles (they never
  worked anyway).

* Conditions can be separated by commas.

* Removed MoveSmoothness command.

Changes in beta release 2.3.17 (May 2000)

* The commands Refresh and RefreshWindow apply all outstanding visual
  changes of a window.

* New options GrowUp, GrowDown, GrowLeft, GrowRight to the Maximize
  command.

* New command ResizeMove combines Move and Resize commands.

* New options "keep" to Move command to leave either coordinate unchanged.

* New options "bottomright" and "br" to Resize command.

* Resize command can take negative arguments.  A "keep" argument leaves
  the corresponding dimension untouched.

* New condition "MovedButton3" that is true if the last interactive
  Move command was finished by pressing mouse button 3.

* Mouse button 3 can no longer be used to cancel interactive window
  movement.

* $FVWM_USERHOME used to set the fvwm user directory renamed to $FVWM_USERDIR.

* The default fvwm user directory is now $HOME/.fvwm, not $HOME,
  the fvwm user directory is now created if needed.

* It is suggested to put all personal fvwm files to $HOME/.fvwm; to simulate
  the old fvwm behaviour, export FVWM_USERDIR=$HOME.

* Instalating fvwm goodies is now to share/fvwm (FVWM_DATADIR), not etc/fvwm.

* fvwm-config utility can be used for querying fvwm instalation.

Changes in beta release 2.3.16 (April 2000)

* Wait command supports quoted window names.

* Fixed the annoying rxvt text selection problem that was present
  since 2.3.10.

* New style option BorderColorset and HilightBorderColorset.

Changes in beta release 2.3.15 (February 2000)

* Reduced memory usage of multiple window styles.

* Documented previously undocumented GotoDeskAndPage command.

* New parameter 'prev' for GotoDesk, GotoDeskAndPage and MoveToDesk
  commands.

Changes in beta release 2.3.14 (February 2000)

* New style option ParentalRelativity to enable Fvwm modules to use
  'Transparent' colorsets from FvwmTheme.  'Opacity' turns it off.

* The GlobalOpts command was removed in favour of individual
  window styles.  Please look for GlobalOpts in the man page to
  find out how to get the old functionality.

* The WindowshadeAnimate command was replaced with the
  WindowshadeSteps window style.

* New MenuStyle option SelectOnRelease to better emulate Alt-Tab.
  Same option for WindowList command.

Changes in beta release 2.3.13 (January 2000)

* New FvwmTheme option 'Transparent'.

* New style option 'IconFont'.

* New style option 'Font' replaces the old WindowFont command.

Changes in beta release 2.3.12 (December 1999)

* New command PointerKey.  Similar to 'Key' command but binds
  keystrokes to the window under the pointer instead of the window
  that has the keyboard focus.

* New WindowList options NoOnBottom, OnBottom and OnlyOnBottom.

* New FvwmTheme colorset options 'Plain' and 'NoShape'.

* New window styles HilightFore, HilightBack and HilightColorset
  replace the old commands HilightColor and HilightColorset.

* The ButtonStyle, TitleStyle and BorderStyle commands take effect
  immediately, without a Recapture.

* The WindowList menu uses the WindowList menu style if it is
  defined.

* The CursorStyle command accepts two new cursors: 'None' for no
  cursor and 'Tiny' for a single pixel cursor.

* A new configurable script fvwm-menu-headlines to show headlines
  of some popular web sites in your fvwm menus. Supported sites:
  FreshMeat, LinuxToday, Slashdot, Segfault and more to come.

Changes in beta release 2.3.11 (December 1999)

* Sticky icon titles are drawn similar to sticky window titles.

* New option NoHotkeys to WindowList command.

* The CursorStyle command has been improved.  It is now possible
  to restore the default cursors.  Xpm images without a hot spot
  can be used as cursors.

* New styles BackingStore/BackingStoreOff and SaveUnder/SaveUnderOff.

* Any changes in your configuration file are applied during a restart now.
  (This obsoletes the contrary entry for 2.3.6.)

* New FvwmIconMan options: IconButton and IconColorset to control colors for
  iconified windows.

Changes in beta release 2.3.10 (December 1999)

* Fixed build problem without shape extension.

* New FvwmIconBox option: FvwmIconBoxUseSkipList.

* New 'flat' and 'sunk' options to BorderStyle command.

* New commands DefaultColorset and HilightColorset.

* FvwmBacker is now page-aware, using a new configuration syntax.

* New styles TitleAtBottom and TitleAtTop.

* FvwmIconBox, FvwmIconMan, FvwmTaskBar and FvwmWinList support animatation via
  FvwmAnimate.

* New command StrokeFunc to handle mouse stroke.

* The default root cursor, unless specified otherwise, is now left pointer.

* New command BusyCursor to control a busy cursor during execution of
  certain commands.

* CursorStyle can set the root cursor and use X11 cursor name.

* New command EscapeFunc to configure an aborting key sequence
  (default is Ctrl-Alt-Escape).

* New command HideGeometryWindow to hide the size/position when moving or
  resizing windows.

* New options for the WindowList command: UseListSkip and OnlySkipList.

* New FvwmPager options SolidSeparators and NoSeparators.

Changes in beta release 2.3.9 (October 1999)

* Color names from colorsets can be used in fvwm command ($[fg.cs<n>],
  $[bg.cs<n>], $[hilite.cs<n>] and $[shadow.cs<n>]).

* FvwmScript supports colorsets.

* FvwmTaskBar supports colorsets with the options Colorset, IconColorset and
  TipsColorset.

* New function variable $v.

* Menus can use colorsets with the new MenuStyle options MenuColorset,
  ActiveColorset and GreyedColorset.

Changes in beta release 2.3.8 (September 1999)

* New Style options ResizeOpaque and ResizeOutline.

* A long-awaited new default FvwmBanner logo.

* RaiseTransient no longer flips main above/below already raised transients.
  New style FlipTransient turns flipping back on, and additionally does a
  similar job for LowerTransient at the bottom of the layer.
  New style StackTransientParent augments Raise/LowerTransient.

* Icons have been removed from the fvwm package and are available at
  the fvwm web site.  (Temporarily only at "xxx.fvwm.org" instead of
  "www.fvwm.org".)

* New command BugOpts enables various former bug fixing compile
  time options to be changed at run time.

* FvwmWharf and FvwmBacker support colorsets.

* A new special fvwm function StartFunction is introduced. It is supposed to
  be used to start modules and for other start commands. This function is
  executed before InitFunction and RestartFunction.  Any commands currently
  in both the InitFunction and RestartFuction can be moved to the new
  StartFunction.

Changes in beta release 2.3.7 (August 1999)

* FvwmButtons and FvwmIconBox support colorsets.

* The old Panels feature of FvwmButtons has been removed. A
  re-implementation has been written.

* The *FvwmButtonsButtonGeometry option makes sizing the
  individual buttons very easy.

* FvwmAnimate accepts "animate" commands from other modules or
  other sources of commands thru "sendtomodule".

* More menu Shortcut keys: Tab moves down, Shift Tab moves up,
  Space executes.  You can now reasonably operate the built-in
  windowlist with one hand.

* Six new color gradients can be used in TitleStyle, BorderStyle,
  ButtonStyle and MenuStyle commands (BGradient, DGradient,
  SGradient, CGradient, RGradient and YGradient).

* MoveSmoothness command allows to tune smoothness of window
  moves. Use lower values on fast machines, higher values on
  slow machines.

* Subwindows can have a private colormap too.

* FvwmButtons uses variables in actions and when swallowing
  applications ($left, $right, $top, $bottom, $width, $height,
  $fg, $bg). See man page for details.

* New menu generating scripts fvwm-menu-directory,
  fvwm-menu-desktop and fvwm-menu-xlock (was BuildXLockMenu).
  There are man pages and --help option for all fvwm-menu scripts.

* Geometry (-g) command line option to FvwmButtons.

* *FvwmPagerSloppyFocus option: To focus a window, simply move the
  pointer over the window's mini window in the pager.

Changes in beta release 2.3.6 (August 1999)

* New function variables $c, $r, $n.

* The new commands QuitSession, SaveSession, SaveQuitSession allow
  to manage the session from the window manager.

* If you use xsm session manager, which has buggy discard command
  implementation, set environment $SESSION_MANAGER_NAME to "xsm".
  If you use another SM, unset this variable or set to something
  else.

* New module FvwmTheme for creating Colorsets that can be shared
  with fvwm and other modules when they have been modified.

* If you never define an iconbox, or you fill all the iconboxes,
  fvwm has a default icon box that covers the screen, it filled
  top to bottom, then left to right, and has an 80x80 pixel grid.

* The new styles LowerTransient and DontLowerTransient allow to control if the
  transients of a window are lowered when the window itself is lowered
  (default) or not.

* The Restart function has been partially rewritten. If you were using
  'Restart' without any parameters and wonder why changes in your configuration
  file are not used during a restart you should use
  'Restart --dont-preserve-state' instead.

* New menu styles VerticalItemSpacing and VerticalTitleSpacing allow control
  over the height of menu items and titles.

Changes in alpha release 2.3.5 (July 1999)

* New special functions Session{Init|Restart|Exit}Function are called instead
  of {Init|Restart|Exit}Function when running under a session manager.

* New form for setting root cursor: FvwmForm FormFvwmRootCursor. .

* Fvwm web files are now in a separate CVS tree.

* All modules except FvwmScript and FvwmGTK share fvwm's visual.

* The behaviour of the Raised and Visible flags for Next, Circulate, ...
  commands has been changed. They now do what their names suggest, i.e.
  visible = partially visible and raised = fully visible.

* The new styles RaiseTransient and DontRaiseTransient allow to control if the
  transients of a window are raised when the window itself is raised (default)
  or not.

* A new action type 'H' for 'Hold' can be assigned to complex fvwm functions.
  It is triggered when the button is pressed and held longer than ClickTime
  milliseconds.

* The activedow-button and inactive-button configure options have been replaced
  with the ButtonState built in command.

* Most of the configure options have been removed.

* The cursors used for resizing and selecting windows and handling menus have
  changed.

Changes in alpha release 2.3.4 (June 1999)

* Fvwm is GNOME compliant.

* Dynamic menus enhancement: The special menu item name 'MissingSubmenuFunc'
  alows to create submenus on the fly. See manpage on 'AddToMenu' for details.

* The Restart command accepts simple shell-like syntax now.

* Added support for mouse strokes recognition, uses LibStroke 0.3
  by Mark Willey(willey@etla.net).
  (http://www.etla.net/~willey/projects/libstroke/)

Changes in alpha release 2.3.3 (June 1999)

* There can be two mini icons per menu label instead of one now.

* Menu enhancements: the layout of the menu items can be controlled in detail
  with the ItemFormat option for the MenuStyle command. The width of the
  borders around menus and hilighted items can be controlled with the
  options BorderWidth and Hilight3DThickness (MenuStyle). Menu behavior can
  be mirrored with the SumbenusLeft option (hard to describe, it's best to
  try it out). A menu item can get up to three different labels. The first
  two are left aligned, the third is right aligned by default.

* Colour gradients may use up to 1000 colours. The old limit was 128 colours.

* New command MaxWindowSize limits the initial dimensions of a window.

* Include fvwmbug script for reporting bugs.

* New button states ToggledActiveUp, ToggledActiveDown, ToggledInactive
  for customizing, as an example, the "maximized" appearance of the
  maximize button.

* New button style flag MWMDecorStick to support toggle buttons for the
  Stick function.

* New condition [!]shaded for Current and other commands taking conditions.

* New menu styles HoldSubmenus/DeleteSubmenus. HoldSubmenus is the new default
  for mwm and fvwm menus. When you move back from a submenu to its parent menu
  the submenu remains visible.

* Menus can be visible multiple times at once.

* Restarting fvwm no longer moves the viewport to (0,0).

* New style DepressableBorder/FirmBorder to influence the appearance
  of the window border under button presses.

Changes in alpha release 2.3.2 (May 1999)

* The Alt-Tab binding to invoke the window list as described in the FAQ
  is  now built-in.  You can remove it as described in the fvwm man page.

* The MoveThreshold command lets the user fine tune the threshold when a click
  becomes a move. It works in FvwmPager too.

* New style IconOverride/NoIconOverride/NoActiveIconOverride to
  influence the overriding behaviour of the Icon style.

* The FvwmCommand module is now much faster and can thus comfortably be used in
  shell scripts. The tradeoff is that it does not report errors any more. To
  get the old behaviour run FvwmCommand with the '-i 1' option.

* Dynamic menus are provided by the special menu items 'DynamicPopupAction' and
  'DynamicPopdownAction'. See the man page on 'AddToMenu' for details.

* System-wide config files are now in ${sysconfdir}/fvwm
  (i.e. /usr/local/etc/fvwm by default) as many files are now installed there.

Changes in alpha release 2.3.1 (April 1999)

* New button style flag MWMDecorShade to support toggle buttons for shaded
  windows.

* Daily snapshots of the development sources available on our web page.

* FixedPosition style: disables moving the window.

* IgnoreRestack style: forbids clients to change their own stacking
  order position.

* The NoWarp option to the Focus command for focusing window on a different
  page without switching to that page.

* Fvwm raises icon titles when the pointer is over the icon.

* The cursors used for the pan frames at the edge of the screen can be changed.

* StaysOnBottom style.

* ResizeHintOverride style: a window with this style can be resized beyond the
  program supplied minimum and maximum size. This is a hack to make fvwm
  cooperate with broken applications.

* NeverFocus style: windows with this style never receive the focus.

* New command: DefaultIcon to set the default icon.

* New command line arguments -visual and -visualId.

* GrabFocusTransient is a new style that does the same as GrabFocus, but only
  for transient windows.

Changes in alpha release 2.3.0 (February 1999)

* FvwmPipe and FvwmConfig modules have been removed.

* New command: RecaptureWindow captures a single window.

* 'GotoDesk' command replaces former command 'Desk' (the old name is still
  supported.

* 'Restart fvwm2' preserves almost all per-window using the file
  $FVWM_USERHOME/.fvwm_restart.

* #define PICK_TRUECOLOR will make fvwm use the best TrueColor Visual.  This is
  for those poor unfortunates with legacy apps that crash if the default visual
  is not an 8 bit PseudoColor (but fortunate enough to have a 24 bit server
  that supports both 8 bit and 24 bit TrueColor)

* New command line argument -replace. fvwm will try to "take over"
  from a running wm only if it is given.

* ImagePath and ModulePath commands now expand '+' to be the
  previous value of the path.

* Key and mouse bindings take effect immediately. A 'Recapture' was necessary
  before this change.

* Unmaximizing keeps windows on the same page.

* Maximize can now expand until some other window is found to fully utilize
  available screen space.

* Use the 'GrabFocusOff' style to prevent ClickToFocus windows taking the focus
  from other ClickToFocus windows when they are mapped the first time. The
  opposite option is called 'GrabFocus' and can be used in conjunction with
  MouseFocus and SloppyFocus too.

* New command IgnoreModifiers for ignoring the pesky num-lock key with
  key and mouse bindings.  Hint: try this command with XFree86:

    IgnoreModifiers L25

  If you encounter performance problems please consult the manpage and the FAQ.

* Enhancements to MoveToPage and GotoPage: 'prev' option to refer to the last
  visited page, negative numbers refer to lower/right page, suffix 'p'
  indicates page number relative to current page.

* Mailcheck interval option for FvwmTaskBar.

* Colorlimit command does nothing if display depth is greater than 20.
  This helps if you want to use the same configuration on more than one
  display depth.  ColorLimit defaults to ON if display depth is 8 bits
  or less.  This should help new users.

* Maximize can now expand until some other window is found to fully utilize
  available screen space.

* FvwmWinList option *FvwmWinListFollowWindowList to display the order that
  fvwm keeps windows in. You can now see the order that Next/Prev will take,
  Prev goes down the list, Next goes up (from the bottom).

* WindowID command now takes conditions like Current.

* Improved cursor support: CursorStyle now supports changing
  cursor colors and creating cursors from xpm files.

* New style options: StartsLowered, StartsRaised.

* New function PlaceAgain: moves a window to where it would be placed.

* New module FvwmGtk. It implements menus, dialogs and window-lists
  using the GTK toolkit.

* NoInset is independent from HiddenHandles, it now works on NoHandles style
  windows.

* Made FvwmPager a bit simpler. Added -transient options to bind a transient
  pager to mouse buttons (see FvwmPager man page for an example).

* VMS port; see vms/README for details.

* New MenuStyle options: PopupAsRootmenu, PopupAsSubmenu

* The 'extras' directory has been merged into 'modules'; the
  --enable-extras configure flag is obsolete.

* New command: Silent. Suppresses user interaction when a window is needed but
  none is selected.

* New utility xselection which can be used with PipeRead to feed the
  content of the X Selection as commands to fvwm.

* Fvwm can now "take over" from a running (ICCCM 2 compliant) wm.

* FvwmPager can now handle pixmaps as desk backgrounds.

* Layer information is displayed in WindowList.

* Animated window shading.

* Shaded windows can be resized.

* Windows can be shaded and maximized.

* Fonts and colors are no longer hard-coded on the FvwmAnimate customization
  form.  FvwmForm can set defaults that the FvwmAnimate form will use.

* New commands All and Pick.

* New command XORPixmap for increased visibility of the rubber band lines and
  general spangly-ness.

* New start up sequence: all start up scripts etc. are read before the initial
  capture so windows styles will be correct, no need for a recapture.

* EdgeThickness can resize/hide/show panframes in mid function.

* Support for transparent Eterms etc. during opaque/animated moves.

* FvwmPager tracks windows during opaque/animated moves.

* Session management. Fvwm talks to a session manager
  and saves and restores its state.

* Layers. New commands Layer, DefaultLayers; new Style
  option, WindowList option and condition Layer.

* Lots of changes to FvwmForm:
  No limits of form size.
  Fonts and colors can change anywhere in the form.
  Form appearance can be configured globaly:
    Form defaults are read from .FvwmForm.
    There is a built in Default setting/saving dialogue.
  Forms can be read in directly from a file.
  Some forms are installed automatically.
  Tab to previous field.
  You can control vertical spacing on text so spacing is OK for help panels.
  A button can execute a synchronous shell command.
  You can paste into a form
  Forms can read configuration data.

* IconPath and PixmapPath are replaced by single ImagePath.  All
  images, no matter what their format are searched for along the
  ImagePath.

_+_A NAME="2.2.5"_-_
Changes in official release 2.2.5 (February 2001)
_+_/A_-_

* When fvwm is run remotely, startup is noticably faster.

* Fixed the description of Focus in the man page.

* Fixed a compile problem with Slackware 7.1.

* Security fix related to .fvwm2rc being searched in the current directory
  when $HOME is not set.

* A small fix in the code for SmartPlacement.

* Core dump fix in pixmap code.

Changes in official release 2.2.4 (November 1999)

* Fixed HP-UX 10.20 build problems.

* Fixed build problems without shape extension.

Changes in official release 2.2.3 (October 1999)

* Several minor bugfixes.

* Fixed dragging windows out of the pager.

* Added support for StartFunction & ImagePath not to break new configurations.

* Fixed long-window-name-hangs-X bug.

Changes in official release 2.2.2 (May 1999)

* New "Emulate"  command  for independent  control of the  move/resize
  feedback window.

* EdgeThickness command can be issued at any time.

* Pan frames not created when not needed.

* Pan frames reach corners.

* Fixed window wandering on restart, recapture.

* International characters are accepted as input in FvwmForm.

* Fix bug in window shading that left one row of pixels visible.

* Fix to FvwmTaskbar so that  it won't loop  when  there are too  many
  buttons.

* Fix positioning bug on overlapping menus.

* Fix M4 command problem, Problem Reports 201 and 246.

* Fixed bug when calling a function without all args supplied.

* Miscellaneous bug fixes,  see ChangeLog for details.

Changes in official release 2.2 (February 1999)

Changes in alpha release 2.1.13 (February 1999)

Changes in alpha release 2.1.12 (February 1999)

* Enhanced and changed the syntax for menu position hints. If you use negative
  offsets you will have to change your configuration now.

Changes in beta release 2.1.11 (January 1999)

* Renamed MenuStyle options: PrepopMenus to PopupImmediately and
  PrepopMenusOff to PopupDelayed.

Changes in beta release 2.1.8 (January 1999)

* New options SidePic and SideColor to MenuStyle

* Configure generates a summary at the end of processing.  In particular
  this is useful to see if any of XPM, Readline, or RPlay are missing.

* Configure now looks in more places to find cpp.  If cpp can't be
  found, you will need to specify '-cppprog' if you use the FvwmCpp
  module.  A warning to this effect is printed at configure time.

* Configure now tries harder to ensure that XPM is the right version.

Changes in beta release 2.1.7 (December 1998)

* The SetMenuStyle command does not exist anymore. Its functionality has
  been merged with MenuStyle. MenuStyle supports the old and the new syntax.

Changes in beta release 2.1.6 (December 1998)

* Recapture is now much faster

* New command "EdgeThickness" to control the size of the pan frames, and
  a new way to turn off mouse edgescrolling.

* new commands DefaultFont, DefaultColors and Emulate

* SetMenuStyle was completely rewritten to get a 'Style'-like syntax.

* Removed SetMenuDelay command.

* Popup menus can have a default action too.

* FvwmButtons quoting cleaned up a bit.

Changes in beta release 2.1.5 (December 1998)

* SnapAttraction works for windows and/or icons. New command SnapGrid.

* The WindowsDesk command is now obsolete. It has been replaced with the
  MoveToDesk command, which uses an argument syntax identical to the
  enhanced Desk command, and allows constraining a move within a range
  of desks.

Changes in beta release 2.1.4 (December 1998)

* Fvwm creates an environment variable FVWM_MODULEDIR containing the path
  to the default module directory, for use in config files, etc.
* The extras module FvwmCommand installs its user interface into the
  bindir rather than the moduledir.

Changes in alpha release 2.1.3 (November 1998)

* Switched to GNU autoconf
* COPYING policy file
* Improved menu handling: Menu position hints, individual menu styles,
  cursor key navigation, animated menus :-)
* Improved window movement: AnimatedMove, SetAnimation, SnapAttraction
  (like in KDE), move/resize can be aborted with a mouse button, Warp option
  to Move/AnimatedMove.
* Direction command (allows to switch windows via cursor (or other) keys in an
  intuitive way).
* Recapture command is now faster.
* Startup is a bit faster if you have a large configuration file and
  a high ClickTime.
* Desk/Page handling: $d in functions is replaced by the current desk number,
  Desk parameters can be given a min/max allowed desk number, making a window
  sticky moves it to the current page, MoveToDesk and MoveToPage functions,
  enhanced WindowsDesk function
* Styles: temporary GlobalOpts command, MouseFocusOnStartup, StipledTitles
* Upgraded versions of FvwmCommand (1.5.1), FvwmConsole (1.3) and
  FvwmIconMan.
* FvwmPager: Balloons (small text windows with the window title appear in the
  pager), current desk (always the current desk on the pager).
* FvwmButtons improvements: animated panels (like CDE), better button
  shuffling, button geometries (x and y position).

Changes in alpha release 2.1.2 (November 1998)

* Modules FvwmCascade and FvwmTile were replaced with FvwmRearrange.
* Improved Shadow/Hilite algorithm (from scwm).  Logic moved into
  library and all modules with 3D logic now use this routine.
* SnapAttraction Command: If during an interactive move a window comes
  within a certain distance in pixels of another it will be moved to
  make the borders adjoin.
* ...MenuStyle commands: allow to name different menu styles and apply them
  to individual menus.
* Direction command

Changes in alpha release 2.1.1 (October 1998)

* Official home page html added to docs directory.

Changes in alpha release 2.1.0 (October 1998)

* basic autoconfiguration support; see INSTALL.fvwm and INSTALL
* modules installed into ${libexecdir}/fvwm/${VERSION}
  - since the version string is encoded into the module directory, it
    is safer to rely on the compiled-in ModulePath, rather than
    setting it yourself in .fvwm2rc
* system configure (system.fvwm2rc) searched for in ${sysconfdir}
* FvwmCpp and FvwmM4 no longer define FVWMDIR variable; instead they
  define FVWM_MODULEDIR and FVWM_CONFIGDIR
* FvwmAnimate added.
* Starting with this release, fvwm is in a public CVS tree.

Changes in alpha release 2.1-pre-beta AKA 2.0.47

        1. FAQ updates
        2. Menu code & Move fixes & enhancements based on patch from
           Greg Badros [+ some bugfixes]
        3. Added SetEnv function (also from Greg's patch)
        4. Fixed some memory leaks
        5. Cleaned up some ugly code pointed out by Peter Seebach
           (like mystrcasecmp & mystrncasecmp - are these even needed
           anyways?  Is there any system that doesn't have the non-"my"
           versions?)
        6. Builtin WindowList no longer searches for xpm's in window
           titles (patch from Greg Badros)
        7. Various compiler fixes
        8. Created textures directory, put Martin Cartwright's
           "marbles" and textures from http://www.PLiG.org/xwinman/ in
           there as a start
        9. Pager balloon window patch from Ric Lister
        10. Signal handler safety patches (based on patch from Grant
            McDorman)
        11. Cleaned up and consolidated allowed function checking code
        12. Made GetTwoArguments check for 'MxN' style numbers so cmds
            like 'DeskTopSize 2x3' will work (since the man page has
            always said that is the proper syntax)
        13. Fixed some minor parsing bugs
        14. Added check to GetWindowSizeHints to compensate for bad
            aspect ratios (fixes some windows that startup HUGE)
        15. Patch to FvwmButtons to add animated panels to it (like CDE
            or Wharf) from Jui-Hsuan Joshua Feng <fengj@percy.engr.wisc.edu>
	16. Brady Montz <bradym@cs.arizona.edu> is the new maintainer.
	17. The Imakefile for FvwmCpp sets FVWM_CPP to CppCmd. If Imake
            is incorrectly configured, you have to override this in Fvwm.tmpl.
	18. New version of FvwmIconMan
	19. Changed prototype of bzero() in alpha_headers.h.
	20. Applied Iconbox patch which added new styles IconGrid and IconFill
            from Dan Espen.
	21. Applied Colorlimit patch which adds ColorLimit command to set
            maxmimum number of colors fvwm can use for pixmaps from Dan Espen.
	22. Applied DontFocusOffscreen patch.
	23. Added StipledTitles globalopt.
	24. Fix to fvwmrc_convert from Pete Forman.
	25. Added FvwmEvent module (successor to FvwmAudio). Added notice to
	    FvwmAudio manpage to start using FvwmEvent.
	26. Added a usleep() for machines which don't have them. Set
	    HAVE_USLEEP accordingly in configure.h.
	27. Changed Fvwm.tmpl to use the CCENVSETUP Imake variable when
	    building executables to fix problem where run-time load path
	    wouldn't be set correctly on solaris.
	28. Added Albrecht Kadlec's SetupModule() routine to fvwmlib.
	29. Integrated MouseFocusOnStartup patch.
	30. Put my fvwm configuration in sample.fvwm/BradyMontz.
	31. Added FvwmAnimate which animates window Iconification.  This is
            a port from Afterstep with enhancements by Dan Espen.
	32. Extracted parsing routines from FvwmEvent and put in the libs
	    directory for general use.
	33. Modules can now operate synchronously with fvwm thru the
	    M_LOCKONSEND flag (from Afterstep).
	34. Modules can now be interactively configured with the M_SENDCONFIG
	    flag.
	35. Dominik Vogt <dominik.vogt@fvwm.org> is temporarily the new
	    maintainer.
	36. Added menu positioning patch and lots of bugfixes in the menu code.
	37. Improved FvwmButtons to recognize button geometries and did some
	    bugfixes.
	38. Enhanced FvwmPager to allow showing always the current desk.
	39. A range of valid desk numbers can be given to any command using
	    desks.
	40. New module XResources in the library to help future modules
	    parsing configuration files and XResources.
	41. Added a bugs section to the FvwmCpp manpage.
	42. Did some cleanup on the manpage.
	43. Added MoveToDesk and MoveToPage builtins and improved WindowsDesk
	    command.
	44. New variable $d for functions to get desktop number.
	45. The RaiseLower bug has been fixed.
	46. Enhancements to cursor navigation in menus.
	47. Improved warping with menus.
	48. Fixed memory leak and possible coredumps in WindowList function.
	49. Fixed bugs in Parse.c in the library and added some convenience
	    function.
	50. Improved adding titles to menus.
	51. Changed the syntax of Prev, Next, None and Current. The old
	    syntax is still supported (but undocumented).
	52. Renamed 2.0.47 to 2.1-pre-beta.

2.0.46

Aug 20, 1997

Version 2.0.46 is now available, at long last...  Doesn't have all of
the stuff that I wanted to get in there, but it was taking WAY too
long for me to put it together, so the rest will have to wait until
2.0.47.  Namely, if you were looking for the animated menus patch or
the colorlimiting patch, some variation of each of those will most
likely appear in 2.0.47.  The march towards 2.1.0 continues...

Also, PLEASE be sure to read the ChangeLog entries each time you
upgrade to make sure you don't miss anything that might require you to
change something in your .fvwm2rc, etc.

       1. Patch to remove forgotten CLICKTORAISE #if check, from
          Markus Gutschke
       2. More mini xpm files
       3. Fix to XTerm font change problem
       4. There is no 4...
       5. Updated extras/FvwmScript from Frederic Cordier
       6. Changing default XORValue to 0, which now means "try and
          guess what a good XORValue is for my display" (using recommended
          method in the XLib Programming Manual)
       7. Updated FvwmM4 & Cpp man pages to show correct invocation...
       8. Updated extras/fvwmperl from Dan Astoorian
       9. FAQ updates
       10. Imakefile fixes
       11. Added info to FvwmIdent (transient)
       12. Brought back 1.xx like CursorStyle command (based on old
           patch from Kit Smithers)
       13. Patch from Patrice Fortier to allow xpm backgrounds in
           FvwmButtons (noticed some problems with this)
       14. Updated FvwmCommand from Toshi Isogai
       15. Builtin WinList fixes (geometry string makes more sense now,
           plus alphabetic sort option from Eric Schott)
       16. Fix from Andrew for NoButton 0 problem
       17. GetDecor SCO CPP patch from Andrew
       18. Patch from Andrew for MWM buttons functions problems
       19. Fix from Dave Goldberg for NoTitle & MiniIcon conflict
       20. Move/Resize frame drawing bug patch from Makoto Matsushita
       21. Patch to FlipFocus (under MouseFocus) from Markus Gutschke
       22. Added patch from Rob Whapham/Thimo Jansen for FvwmPager
           miniicons (plus small enhancements)
       23. FvwmBacker patch from Tim Phipps to have it run fvwm
           commands instead of unix commands, so borders & the like
           can be changed too (just use Exec to get old functionality)
       24. Latest FvwmIconMan (v1.0) from Brady Montz
       25. Fix for static buffer overflow in SendDataToModule in read.c
           (when IconPath/PixmapPath greater than 255 chars)
       26. Patch from Tim Phipps to add Current op (like Prev & Next,
           but operates only on Current window) and enhanced conditionals
           for Prev/Next/Current/None (like the addition of !<name>)
       27. Added FvwmWharf to extras dir (ported from AfterStep by Peter Gray)
       28. Added FvwmTaskBar to extras dir (ported from fvwm95 by Don Mahurin)
       29. Added FvwmWinList miniicons patch from Don Mahurin.  Still
           need to update docs for it...
       30. Patches from Randy Ray to make windowshade module packets
           more "standard" & add filename to MINI_ICON packet
       31. Patch from Barry Warsaw to make multi head code work
           slightly better (although it probably needs a total rewrite
           to really work well - ctwm good model?)
       32. Patch to echo builtin needs to remove final \n if there is
           one (Greg Badros sees this, but I don't so it might be a system
           dependent bug)
       33. Patch from Dan Espen for keeping long icon names on screen
       34. Made builtin function searching faster (hopefully) using
           simple binary search (mostly to help speed up startup
           time).  Please let me know how this works since my
           relatively simple setup isn't a good test case for this...
       35. Removed 'raise_it' entirely, since no longer used
       36. Made window move paging match Edgescroll values instead of
           always doing full screens (should this be an option?)
       37. Focus command no longer raises - use an interpreted
           focus-and-raise function if that's desired
       38. Minor menu code bug fixed - wasn't always ungrabbing the
           cursor before executing function (timing dependent - most
           of the time ok)
       39. Fixes for DEC Alpha compile warnings
       40. Fix for IconBox -0 handling, from Ric Lister

2.0.45

Jan 22, 1997

Version 2.0.45 is now available.  Ok, 2.0.44 had a few flaws in
there... :)  This is essentially a quick bugfix release.

       1. Patches to WindowShade stuff, from Andrew Veliath
       2. Man page corrections & updates
       3. UseStyle fixes from Andrew
       4. CleverPlacement and RandomPlacement fixes from Anthony Martin
       5. Added (De)WindowShade module msgs
       6. FvwmAudio fix (for MINI_ICON & (DE)WINDOWSHADE)
       7. FvwmAuto fixes from Albrecht
       8. DestroyDecor window shrinkage fix, from Andrew
       9. Fix to Wait command lockup (from Makoto Matushita)
       10. Fix to undocumented LEFT_MENUS stuff (from Dan Espen)
       11. Updated FvwmIconMan to Brady's latest, and made it use
           GetFdWidth instead of sysconf for portability (patch from
           Makoto Matushita)
       12. Patch to make CLICKTORAISE define be GlobalOpts
           MouseFocusClickRaises option, from Randal Winchester
       13. Fixes for problems w/ B&W visuals with new
           EXTENED_TITLESTYLE stuff, patch from Andrew
       14. WindowsDesk patch from Pekka Marjola to be able to move
           relative to current desk (now matches Desk builtin, plus
           handles old behavior)
       15. Added decor_examples in sample.fvwmrc dir, which contains a
           few examples of the new Decor/BorderStyle/TitleStyle stuff
           (from lar3ry gensch, Martin Cartwright, Paul Smith)

2.0.44

Jan 15, 1997 (figured I should start putting dates in here...)

Version   2.0.44 has finially been released,   with lots of fixes, and
some  new stuff that I  finially gave in on.   For all you fans of the
various  fvwm hacks that keep   showing up (fvwm95, fvwm-xpm, etc)  be
sure      to   check   out  the    new    optional   at   compile time
BorderStyle/TitleStyle/UseDecor stuff...    I'm     looking for   good
examples for them to put in the sample fvwm2rc files.  If anyone comes
up with some that  they might like to   contribute, feel free  to mail
them to the fvwm mailing list.

       1. More man page and FAQ updates
       2. More minor Imake fixes
       3. Patch for IconGeometry placement problems and probs running
          on multiple displays from Graham Barr
       4. Changed Next/Prev 'CurrentScreen' to be 'CurrentPage' and
          added 'CurrentPageAnyDesk', based on patch by Dan Niles
       5. Updated FvwmIconMan from Brady Montz
       6. Fix so FvwmGoodStuff in extras would compile ok
       7. Added Perl routines (fvwmperl in extras dir) for aid in
          making modules written in Perl, from Dan Astoorian
       8. Hopefully fixed long standing startup timing bug in which
          some windows didn't get Style attributes or borders (by
          fixing when server was grabbed and making sure it didn't get
          ungrabbed to early accidentally)
       9. Added FlipFocus function from Dan Niles, to toggle between
          two windows easily
       10. Patch for EdgeResistance timer problem from Mike Blatchley
       11. Patch to FvwmAudio so it works again (new module message
           type M_STRING wasn't recognized) plus other minor fixes and
           enhancements (like being able to use the rplay 'say'
           command and have arbitrary strings instead of sound file
           names), from Albrecht Kadlec
       12. Fixes to FvwmConsole from Toshi Isogai, plus added his
           FvwmCommand to the extras directory (for sending fvwm
           commands from a shell script).
       13. Patch for dynamic icon title recalculation from Ric Lister.
       14. Updates to fvwmrc_convert from Bill Oswald, with some more
           minor mods from me to make it easier to customize for your
           site.
       15. Added 'Echo' function.
       16. Patch to FvwmForm to handle TrueColor from Chris Laas
       17. Changed fcntl in module.c to use O_NONBLOCK (POSIX) instead
           of O_NDELAY (early SYSV) due to differences in behavior on
           some systems (Pyramid SYSV for instance, pointed out by
           Mark Wedel)
       18. Added Python routines (fvwmpython in extras dir) for aid in
           making moduules written in Python, from Barry Warsaw
       19. FvwmBacker now sets root window when it's invoked as well
           as on desk changes
       20. CatchFatal no longer makes XLib calls (to prevent some
           infinite looping under Digital Unix & Solaris), patch from
           Grant McDorman.
       21. Added Andrew Veliath's TitleBar pixmap patch (optional at
           compile time)
       22. Added patch for timing bug in pager when dragging windows
           across desktops under Solaris from Grant McDorman
       23. Added RefreshWindow function, at the request of Mike Kazda.
       24. Changed default XORValue to 1
       25. Changed SmartPlacement behavior to be "stubborn" (like 1.xx
           StubbornPlacement option) and not place over icons (if you
           don't want this you can compile with NO_STUBBORN_PLACEMENT).
       26. Added extras/FvwmScript (which replaces extras/FvwmForm2)
           from Frederic Cordier (although I think it should be
           renamed to something like FvwmFormScript).  It can now
           swallow programs like FvwmButtons.
       27. Sample .fvwm2rc updates, default system.fvwm2rc file now
           minimal to encourange site customization, added more sample
           files to go with it.
       28. Added info to FvwmIdent
       29. Added MiniIcon patch from Brady Montz (optional at compile
           time)
       30. Added BorderStyle border textures (+ TitleStyle, UseDecor,
           etc) patch from Andrew Veliath, part of which was inspired
           by the idea from 'The Rasterman' Carsten Haitzler (optional
           at compile time)
       31. Consolidated Recapture and CaptureAllWindows
       32. Fixes for unmapping problems (patch from Grant McDorman)
       33. Removed redundancy in module.c in Broadcast* funcs.
       34. Multiple -f & -cmd parms now allowed (10 max)
       35. Merged fvwmlib code into some common files, and moved some
           functions out of fvwm proper into them.
       36. Added GlobalOpts builtin (for various options that should
           become Style options later) - this is temporary.  I know
           it's ugly, but I didn't feel like adding 6 (or more)
           temporary functions (lazy, I know...)
       37. Added (GlobalOpts) global option
           SmartPlacementIsReallySmart (may become parm to
           SmartPlacement, or whole new CleverPlacement style after
           the Great Style Flag Rewrite) which uses clever placement
           code from Anthony Martin
       38. Started adding new parsing code based on ideas in patch
           from Albrecht Kadlec, for more consistent parsing.  More
           and more code in fvwm will be converted to use these...
       39. Added WindowListFunc and made built in window list use it
           by default (instead of RAISE_IT), to allow for various
           actions to be controlled by the builtin window list (like
           to warp the pointer or not warp the pointer when giving it
           the focus, or perhaps do something like run FvwmIdent on
           it).  It is interpreted, so you can destroy it and write
           your own version of this default WindowList function.
       40. WindowList now takes reasonable optional parameters instead
           of those cryptic numbers (including an optional function to
           use instead of the default WindowListFunc), based on patch
           from Albrecht Kadlec.
       41. Added WindowId function, sort of like Next & Prev, to force
           a function to happen on a specified WindowID.
       42. Updated FvwmAuto from Albrecht Kadlec (now takes parameters
           for functions to be run on focus in & focus out).
       41. Read funcs now output what they are going to execute if
           -debug parameter was passed in.
       42. Should now be sending synthetic ConfigureNotify on stacking
           changes (for potential motif menubar problems).
       43. Added WindowShade function from Andrew Veliath
       44. Added (GlobalOpts) global options to modify ClickToFocus
           selections: ClickToFocusDoesntPassClick/PassesClick,
           ClickToFocusDoesntRaise/Raises (may become parms to
           ClickToFocus after the Great Style Flag Rewrite)
       45. UseStyle should now parse quoted Style refs correctly,
           courtesy of Andrew Veliath.
       46. Added Randall Winchester's CLICKTORAISE compile time option patch
       47. Patch from Greg Badros for FvwmButtons font coredump
       48. Patch from Greg Badros so FvwmM4 passes opts not recognized
           directly to M4 (so -m4opt not needed) and -outfile option.
           Added these to FvwmCpp as well.
       49. Fixes for compiling under Linux for DEC Alpha from Ilkka E
           T Tuohela

2.0.43
       1. More man page updates & Imake fixes
       2. Simple patch to help take care of some timing bugs
       3. Patch to fix resize oddities when hitting 'hard' edge introduced
          by EdgeScroll loop patch
       4. Fixed startup w/ no rc bug, plus added more defaults, so if
          started without an rc file, things should run ok.  Plus it now
          outputs error messages if Read fails, then tries to Read
          system.fvwm2rc (after first read fails).
       5. Patch to fix UseStyle problem w/ BackColor
       6. More FAQ updates
       7. Created an 'extras' dir, and moved some of the existing modules
          in there (the ones that aren't being built by default).
       8. More potential speedups in event processing
       9.  Decoupled warp from Focus, adding WarpToWindow function.
       10. Added SendToModule builtin to send arbitrary strings to modules
           to help implement more complex dynamic module abilities and
           allow for module to module communication
       11. Put old FvwmButtons back as FvwmGoodStuff, for people who
           prefer the simpler older version (in extras dir).  Also made it
           able to be passed in the name parameter on invocation so it
           doesn't have to be symbolically linked to the new names any
           more.
       12. Adding a new module FvwmForm2 in the extras directory,
           contributed by Frederic Cordier.  Based on FvwmForm but
           completely rewritten apparently.  It uses scripts, has a new
           more complex syntax (Pascal like) and adds RadioButtons.  I
           would like to eventually combine aspects of the two versions
           (and more) to make one killer module, perhaps.
       13. Made fvwm_msg send errors to modules, so FvwmTalk sees them
           like it used to (and any other module that looks for M_ERROR
           in the future)
       14. Added DestroyModuleConfig, based on patch from Toshi Isogai
       15. Modules can now send module config commands to fvwm (eg FvwmTalk)
       16. Removed implicit Exec exec stuff for the time being, until I
           come up with a better way to do it (back to old behavior)
       17. More mini icons added and some icons removed
       18. Added "KillMe" command that modules can send to fvwm asking for
           an assisted suicide (almost called this Kevorkian :)).  Mark
           Crimmins wanted this for probs with TkGoodStuff.
       19. Fixed RaiseWindow bug under some servers when no icon pixmap.
       20. Fixed one prob w/ FvwmAuto and menus being hidden (under click
           to focus - still needs work for other focus policies, but not
           entirely sure how to approach this yet).
       21. Added ExitFunction, to be executed on exit (before restarts too).
           Useful for explicitly killing modules, etc.
       22. Changed behavior of '-f' to just specify config file (now use
           -cmd to perform an actual command, like -cmd 'FvwmM4 .fvwm2rc')
       23. Updates to FvwmSaveDesk from Carsten Paeth so it should now
           actually work under 2.xx, plus some other bugfixes too I
           believe.
       24. Added PipeRead function, which executes a program and Read's
           it's output.  Useful for making dynamic menus and such.
       25. Security fix for FvwmM4 & FvwmCpp from Austin Donnelly
       26. Added strerror for SunOS 4.1.x
       27. Added ability to remove mouse and key bindings without restart
           (do the binding but specify '-' as the function).  Probably
           needs more checking for removing mouse bindings from title bar
           buttons correctly, though.
       28. Updates to FvwmIconMan from Brady Montz.
       29. Updates to FvwmIconBox from Nobutaka Suzuki.
       30. Patch from Austin Donnelly for multi-keypress required for
           WindowList problem.
       31. Patch to center text on left pixmaps in menus.
       32. Patch to allow menus to pop up left if not enough room on right
           (currently in ifdef -> define LEFT_MENUS to enable when compiling).

2.0.42
       1. More small Imake fixes & man page updates
       2. Optional Xpm support for titlebar buttons patch from Andrew
          Veliath
       3. Made event handler jump table be a bigger default size, since
          LASTEvent doesn't account for X Extension related events (eg
          SHAPE)
       4. FvwmPager display updates: DeskColor patch from Alan Wild,
          line distinctions between desks and pages, reinstated message mask
       5. Patch to make fvwm recognize some OpenLook WM hints (like MWM
          hints) from Andrew Taylor
       6. Added FvwmIconMan module (by Brady Montz)
       7. Replaced FvwmButtons with New & Improved version from Jarl Totland,
          had to patch to get to work ok under AIX (char's are unsigned by
          default under AIX)
       8. Added DestroyFunc for removing function definitions
       9. Made Exec use $SHELL, like mwm, if ExecUseSHELL is specified,
          plus Exec now does an explicit "exec" as the first arg (if it's
          not there already), to eliminate extra processes
       10. Completely replaced fvwm_err (removed) & most fprintf calls
           (those that were appropriate) w/ fvwm_msg (which has
           variable args, a consistent look, and will eventually
           optionally output to a file as well as to stderr)
       11. Fix from Nobutaka Suzuki for probs w/ Next/Prev Focus
       12. Patch from Henrique to make EdgeScroll wrap cleaner
       13. Patches to FvwmIconBox from Nobutaka Suzuki
       14. Patches for caching xpm files, modules having Popups on
           ButtonPress events, & rc line continuation (from Jarl)
       15. Make SHAPE extension runtime determinite in addition to compile
           time so same exec can run on different machines better (John
           Bazik, the author of XMX wanted this) - Haven't fixed up the
           modules that use SHAPE yet though (next release)
       16. New module FvwmConsole (a good potential replacement for
           FvwmTalk) from Toshi Isogai.  Currently won't build as part of
           the normal process (you'll have to do it by hand until I
           integrate it further).
       17. Added more mini icons from list members.
       18. Added new-system.fvwmrc, which is the beginning of a
           reformatted & commented rc file (from Eli Burke).  Feel free to
           provide your $0.02 on it.

2.0.41
       1. More FAQ updates & man page corrections
       2. Patch to limit GetFdWidth to FD_SETSIZE to prevent fvwm from
          eating too much cpu under bsdi if 'unlimit descriptors' is used
       3. Ressurrected desktop edge wrap via EdgeScroll*1000 feature
       4. Fixed library link order (fixes the sometimes undefined
          XLoadQueryFont problem)
       5. Renamed fvwm_icons subdir to be just icons, documentation to be
          just docs
       6. Removed FvwmPrompt (use FvwmForm instead, since it's better anyways)
       7. Todd Fries 'UseStyle' patch
       8. XClientMessages sent to icon windows (that aren't
          XA_WM_CHANGE_STATE ones) are now sent along to to the apps
          window
       9. FvwmButtons fixes from Jarl for incorrectly drawn buttons and
          better no title handling
       10. FvwmForm now uses GetFontOrFixed, instead of silently failing
           if font can't be found
       11. New Imake setup based on patch from Mark Powell (let's see if
           people have less problems with this, since it's more 'standard'
           now)
       12. Changed top directory to contain version number
       13. Modified Style parsing to (hopefully) do less string compares
           for a potential speedup
       14. Modified DispatchEvent to use a jump table instead of a switch
           statement, again for a potential speedup
       15. FvwmIconBox patches from Nobutaka Suzuki

2.0.40
       1. Removed 'basename' reference
       2. More small Imake fixes
       3. Renamed FvwmConfig .cc files to .C, because some C++ compilers
          can't handle the .cc extension (AIX's, for instance)
       4. FvwmForm now gets config info in standard way
       5. FvwmBanner now dissappears if you click on it (like in 1.xx)
       6. Renamed FvwmConfig's makefile to Makefile.std and cleaned it up
       7. More small man page cleanups
       8. Improved handling of nonexistant fonts (added GetFontOrFixed)
       9. More debug messges, and central fvwm_msg function for printing
          msgs (started converting fvwm_err and fprintf calls to use this
          instead, as it has variable args and allows for a consistent
          message feel and I'll use this to add -outfile <file> option
          eventually to capture all fvwm output to a file as well as
          stderr)
       10. Fixed function parm $9 coredump
       11. Added basic TitleStyle (for justfication & edge appearance)

2.0.39
       1. More Imake fixes from Randall Winchester
       2. Started adding optional debug messages, to help people help me
          solve problems that I can't reproduce (a define in configure.h
          to enable these, off by default)
       3. Added -blackout option, to black out screen during init and
          recapture (no blackout is default now)
       4. Removed some unused variables, cleaned up some code that
          generated compiler warnings
       5. More small doc & FAQ updates
       6. Fix for using "None" as font in FvwmPager to not have a Label
          (it now works)
       7. Making Resource = "NoResource" instead of "Untitled" (if class
          hints res_name is NULL) to differentiate between window Name &
          window Resource so Style commands for windows that have a
          WM_NAME but no WM_CLASS don't match Untitled
       8. Simple FvwmWinList refresh patch
       9. Added Imakefile for FvwmConfig (only works under X11R6)

2.0.38
       1. Fixed FvwmPager to die without causing X server to eat CPU if
          running under FvwmButtons & FvwmButtons dies or is killed
       2. Went to new M.I.P version number system in preparation for first
          official release (which will be 2.1.0 - until then fvwm is still
          pre-official release)
       3. Small fix to makefile for FvwmConfig
       4. More [icon_]name == NULL checks/fixes
       5. Added some things left out from Imakefiles, makefile.h & configure.h
       6. FvwmButtons now handles Exec "" foobar correctly.
       7. Added Ludvig A. Norin's wonderful mini xpm icons
       8. Made scanForPixmap keep %name% or *name* in strings (restores
          original string) if pixmaps can't be found (this also allows
          window list to work for names w/ % or * in them too, or actually
          display a pixmap if it's in the window name), and corrected 2 col
          menu display bug that this showed (2nd col text didn't account for
          width of left justified pixmap)

pl 36 to 37
       1. Fixed coredump due to incomplete backout of NoName/NoClass patch
       2. Fix for multiple env var expansion core dump from Sverre H. Huseby
       3. Small doc fixes (spelling, etc)
       4. Imakefile/configure.h enhancements from Randall S. Winchester
       5. Updated system.fvwmrc (FvwmIconBox changes from Nobutaka Suzuki)

pl 35 to 36
       1. Some more doc cleanups & FAQ updates, plus renamed fvwm.man to
          fvwm2.man, w/ symlink for fvwm.man (so install.man works correctly
          with rename of exec)
       2. Made utils subdir for scripts, added quantize_pixmap script
       3. FvwmPagerDeskTopScale patch
       4. Small changes to configure.h defaults, plus added XPMINCLUDE
          and FVWM_MAN_DIR
       5. Added 'make depend' to MakeMakefiles script
       6. Reverting NoClass patch completely, as I think it's causing
          other problems
       7. Small change to make windows seem to close faster (hopefully)
       8. Patches to FvwmButtons to make it behave better when killed
          (kill swallowed modules, catch signals, etc)
       9. Patch from Sverre H. Huseby for env vars in ModulePath, PixmapPath
          and IconPath
       10. Patch to FvwmCpp for -cppopt to work correctly
       11. Added FvwmDebug back to distribution (still needs to be updated)
       12. Added BUGS file for known bugs

pl 34 to 35
       0. New maintainer for fvwm now, please go easy on him :)
       1. Fixed Title & Icon name change bug introduced in pl 34
       2. Applied another patch from Frederic Devernay
                  a. Keeps no class windows having no class & now handles
                     correctly
       3. Removed some extraneous files from the distribution, added
          preliminary FAQ, INSTALL & TO-DO files, added small README.
       4. Made conversion_script runnable
       5. Fixed FvwmPrompt
       6. Patch to rename fvwm & .fvwmrc in configure.h added (on by default)
       7. Compile date & time added to -version.
       8. FvwmBanner Xpm & timeout can now be specified in fvwmrc

pl 33 to 34
       1. Applied patches from Frederic Devernay
	          a. Improved reading of window and icon names
		  b. improved handling of windows with no class.

pl 32 to 33
       1. More fixes to move/resize window when using m4.
       2. Added Sloppy Focus to FvwmConfig. Made FvwmConfig obtain initial
	  focus mode from fvwm.
       3. Add SCREEN macro to fvwmm4.
       4. Applied FvwmWinList patches.

pl 31 to 32
       1. Fixed color specification problem for ForeColor and BackCOlor
	  styles, so things like rgb:rr/gg/bb work again.
       2. Made MWMMenus style take effect on the Size/Resize window
	  even when using M4. Color selection of the Size/Resize window
	  is still broken.

pl 30 to 31
       1. Added patch to make FvwmButtons and FvwmPager accept -0
          geometries.
       2. Added code to FvwmConfig to make it read in current values for
	  colors and desktop sizes as it starts up. Made it handle case
	  of no more colors in colormap.


pl 29 to 30
       1. Added color selection to fvwmconfig

pl 28 to 29
       1. Fixed problem of lost root window key bindings with FvwmM4
       2. Minor adjustments to FvwmConfig. Included a makefile. Compiles
	  with Sun's CC now, as well as with g++
pl 27 to 28
       1. Patch to FvwmButtons to fix the button-popping out problem.
       1. Added FvwmConfig. Requires g++ version 2.6.3 or thereabouts.
	  not automatically built or installed. Do it yourself.

pl 26 to 27
       1. Minor fix to FvwmScroll affecting handling of window resizes.
       2. Fixed core-dump problem (maybe) in pl26
pl 25 to 26
       1. Corlormap handling bug fix.
       2. Finally, after years and years of saying, "thats not a
	  problem because people shouldn't have windows that small",
	  if fixed the handling of the corner pieces for teeny-tiny
	  windows.
pl 24 to 25
       1. Incorporated  colormap-focus patches
       2. Incorporated loads of patches - I have no idea what they
	  do, but at least the following
	   - allow use of ESC key to abort a move/resize
	   - Something about usign pager on B&W  display.
	   - stuff for FvwmIconBox
	   - stuff for FvwmWinList

pl 23 to 24
       1. Man page updates for style function
       2. Added stuff to over-ride motif modal dialogs. Makes apps
          think that mwm is running, but fvwm doesn't handle the
	  modality, so use with care. You have to set the
	  compilation flag: MODALITY_IS_EVIL in configure.h to enable this
	  feature. Netscape users may wish to try this out.

pl 22 to 23
       1. Applied patches to FvwmIconBox and FvwmWinList.

pl 21 to 22
       1. Applied patch to fix up multi-screen support a little.
       2. Changed some strcasecmp calls to mystrcasecmp.
       3. Other stuff, can't remember what! (bug fixes)

pl 20 to 21
       1. Little bug-fix with motif-pop-up/pull-down menus and window
          focus
       2. Applied FvwmIconBox patch.
       3. Applied FvwmButtons patch to let you activate with a key press
          (return key) instead of mouse button.
       4. Re-worked the forking process for multi-screen displays. Can't
          test it, maybe someone can fix it now.

pl 19 to 20.
       1. Fixed resize buglet
       2. applied FvwmIconBox patch

pl 18 to 19.
       1. Not much

pl 17 to 18
       1. Fixed loss of key bindings on root window
       2. Fixed compile error in Picture.c
pl 16 to 17
       1. Applied patch to FvwmAudio.
       2. Allow menu-pixmaps to be above or to the left of
          menu labels, or both.
       3. Adjusted resize behavior for windows whose aspect
          ratio had max == min. Behavior was a little weird before.
       4. Added built-in KillModule
       5. Some changes to allow evil, poorly designed override-redirect
          windows to install their own colormaps. This abuse of override
	  redirect windows is primarily used by WABI, but a few others
	  too, I guess. This change is fairly fundamental, and could cause
	  problems. Also, if WABI comes up with a private colormap, it
	  is given control of the colormap immediately, since it thinks
	  that it should have focus.

pl 15 to 16
       1. Applied patch to make menu short cuts work
       2. Made this menu config work as expected:
	  "*xcalc.xpm*"     Exec  exec xcalc &
       3. Restored ability to insert blank lines in
          menus, not just separators.
       4. Allow bitmaps in menus as well as xpm's
pl 14 to 15
       1. Added option to put pixmaps in menus.
          Modify your menu labels like so:
	  was:

+         "Calculator"     Exec  exec xcalc &
          is
+         "Calculator*xcalc.xpm*"     Exec  exec xcalc &
          pretty kool, man!

pl 13 to pl 14
       1. Assorted minor bug patches.

pl 12 to pl 13
       1. Applied patches
           A. Something about XSetIOErrorHandler. Doesn`t seem to hurt,
	   but I don't know what it does.
       2. Patches for FvwmIconBox. Nobutaka Suzuki has been working hard
          on this top-notch module, and seems to be working to integrate
	  it more tightly with fvwm itself. The latest patches let the
	  IconBox read the Icon pixmap names from fvwm. Icons are only
	  shown in the IconBox if the NoIcon style is applied. Is this
	  right?

	  To get something in the icon-box, you can use
	  Style "XTerm" Icon xterm.xpm, NoIcon

       1. Added FvwmForm module. It looks like its for 1.24r, but seems
          to work with Fvwm-2.
       2. Tried to add Tom Feng's GoodStuff patches, but they are
          incompatible with other changes.

pl 11 to pl 12
       1. Really fixed that memory problem in builtins.c this time.
       2. Fixed the inverting shading of the maximize button
          if MWMButtons is used.
pl 10 to pl 11
       1. Fixed some references to already freed memory areas,
          specifically related to FocusOnNextTimeStamp and Scr.Ungrabbed.
	  Only affected click-to-focus, and only soon after destroying
	  a window.
       2. Plugged a memory leak (?) in builtins.c. Watch out, maybe I
          broke something instead of fixing it. Not sure.


pl 9 to pl 10
       1. Fixed double click on title-button 1 problem. It used to work,
          but only if the mouse was not moved at all. Now, 3 pixels of
	  mouse movement are allowed, and the double-click action will
	  still be performed. After 3 pixels, the double click action is
	  aborted.
       2. Fixed problem with focus in focus-follows-mouse mode, when
          changing desks. Some click-to-focus person sent in a patch which
	  caused focus to be returned to the last window that had focus on
	  desk N, when you switch to desk N. That was fine, but if there
	  was no such window, focus went to a sticky window. That was bad.
	  You see, I'm focus-follows-mouse, but I make most of my sticky
	  windows click-to-focus (ie pager), because I really don't want
	  it to get the focus. The above patch made the sticky window get
	  focus when switching desks, when I really wanted the root window
	  to get the focus (for keyboard activated menus, etc).
       3. Added a DestroyMenu function.


pl 8 to 9
       1. Fixed misc bugs.
              A. Menus popped up in wrong place when NoButton style was
	         used.
	      B. Title bar would look pressed in if you moved out of it
	         by key presses.
       2. Added #define SCREEN 0 (or whatever) for fvwmcpp.
       3. Applied patch to FvwmIconBox.
pl7 to 8
       1. Fixed (probably) some unwanted free()s in the code.
          These caused core dumps on some machines.

pl6 to 7:
       1. Fixed IconBox style
       2. Fixed (?) FvwmM4 problem with not executing InitFunction &
          restartfunction, etc
       3. Fixed FvwmIdent module (Sticky, Ontop, Iconified, etc).
       4. Fixed StickyIcon style.
       5. Fixed FvwmWinList

pl 5 to 6
       1. Applied patch to FvwmAudio
       2. Applied patch to FvwmIconBox
       3. Got patch for m4 handling, didn't do anything.
       4. applied FvwmPager patch to eliminate flicker when
          selecting a window on the current page.
pl4 to 5
       1. Fixed FvwmM4 again.
pl3 to 4
       1. Fixed FvwmM4.

pl2 to 3
       1. Removed an unnecessary debugging printf
       2. Fixed FvwmBanner
       3. switched vfork back to fork, since some people apparantly
          don't have vfork.
       4. Changed the name of system.fvwmrc to .fvwmrc because its easier
          to handle within the program. Modified documentation and the
	  install stuff in the Imakefile
       5. Fiddled with time-stamp stuff a bit, so that maybe when people
          change their system clocks, it won't cause everything to stop.
       6. Fixed a cause of core-dumps in the Next, Prev, None commands.

pl1 to pl2
       1. Assorted trivial bug fixes. Maybe something important too,
          I forgot.

2.0 pl 1:
       1. Switched from fork() to vfork() in two places. Its supposed to
       be better when you're only doing an exec anyway.

       2. Made fvwm parse out module arguments in a more standard way.
       see documentation/modules.tex for more details.

       3. Added FvwmM4 module. See its man page.
       4. Added FvwmCpp module.

2.0 The beginning of time.
